<?php
// Load configuration
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}

if (php_sapi_name() == "cli") {
    //die('Abording. 123Solar cannot be in CLI');
}

// Few checks
$Err   = false;
$input = '{ "jsontest" : " <br>Json extension loaded" }';
$val   = json_decode($input, true);
if ($val["jsontest"] != "") {
} else {
    $Err = true;
    echo '/!\ Json extension -NOT- loaded.';
}

if (!extension_loaded('shmop')) {
    $Err = true;
    echo '/!\ Shmop extension -NOT- loaded.';
}

if ($Err == true) {
    die("Abording. Please update php.ini.\n");
}

if (!extension_loaded('calendar')) {
    echo "Notice : Calendar extension not loaded\n";
}

define('checkaccess', TRUE);

if (is_readable('../config/config_main.php')) {
    include('../config/config_main.php');
} else {
    die("Abording. Can't open config_main.php.\n");
}
if (is_readable('../config/config_pvoutput.php')) {
    include('../config/config_pvoutput.php');
} else {
    die("Abording. Can't open config_pvoutput.php.\n");
}
if (is_readable('../scripts/memory.php')) {
    include('../scripts/memory.php');
} else {
    die("Abording. Can't open memory.php.\n");
}
date_default_timezone_set($DTZ);

@$shmid = shmop_open($MEMORY, 'a', 0, 0);
if (!empty($shmid)) {
    $size = shmop_size($shmid);
    shmop_close($shmid);
    $shmid = shmop_open($MEMORY, 'c', 0644, $size);
    $data  = shmop_read($shmid, 0, $size);
    shmop_close($shmid);
    $memarray = json_decode($data, true);
}
// Date check
$output = array();
$output = glob('../data/invt1/csv/*.csv');
sort($output);
$xdays = count($output);

$nowutc = strtotime(date('Ymd H:i:s'));
if ($xdays > 1) {
    $lastlog    = $output[$xdays - 1];
    $lines      = file($lastlog);
    $contalines = count($lines);
    $array      = preg_split('/,/', $lines[$contalines - 1]);
    $date1      = substr($output[$xdays - 1], -12);
    
    $year   = (int) substr($date1, 0, 4);
    $month  = (int) substr($date1, 4, 2);
    $day    = (int) substr($date1, 6, 2);
    $hour   = (int) substr($array[0], 0, 2);
    $minute = (int) substr($array[0], 3, 2);
    
    $epochdate = strtotime($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $minute);
} else {
    $epochdate = 1242975600;
}
$i = 1;
while ($nowutc < $epochdate) {
    $nowutc = strtotime(date('Ymd H:i:s'));
    echo "Computer time is not correct, trying again in $i sec\n";
    sleep("$i");
    $i++;
    if ($i > 1200) {
        die("Abording..\n");
    }
}

// Initialize variables
$minlist = array(
    '00',
    '05',
    '10',
    '15',
    '20',
    '25',
    '30',
    '35',
    '40',
    '45',
    '50',
    '55'
);

$SCRDIR = dirname(__FILE__);
if (!isset($memarray['awake'])) {
    $memarray['awake'] = false;
}
$GOPVO  = 1; // Go to feed PVoutput
$numsma = 0; // Num of SMA

// Invt config
for ($i = 1; $i <= $NUMINV; $i++) {
    if (is_readable("../config/config_invt$i.php")) {
        include("../config/config_invt$i.php");
    } else {
        die("Abording. Can't open config_invt$i.php.\n");
    }
    
    if (${'PROTOCOL' . $i} == '485solar-get' && ${'DAEMONMODE' . $i} && !${'SKIPMONITORING' . $i}) { // checking num of SMA to call 485solar-get daemon
        $numsma++;
    }
    if (${'SKIPMONITORING' . $i}) {
        $GOPVO++;
    }
    
    $nowUTCs                = strtotime(date('Ymd H:i:s'));
    $livememarray["SDTE$i"] = $nowUTCs;
    $livememarray["I1V$i"]  = 0;
    $livememarray["I1A$i"]  = 0;
    $livememarray["I1P$i"]  = 0;
    $livememarray["I2V$i"]  = 0;
    $livememarray["I2A$i"]  = 0;
    $livememarray["I2P$i"]  = 0;
    $livememarray["I3V$i"]  = 0;
    $livememarray["I3A$i"]  = 0;
    $livememarray["I3P$i"]  = 0;
    $livememarray["I4V$i"]  = 0;
    $livememarray["I4A$i"]  = 0;
    $livememarray["I4P$i"]  = 0;
    $livememarray["G1V$i"]  = 0;
    $livememarray["G1A$i"]  = 0;
    $livememarray["G1P$i"]  = 0;
    $livememarray["G2V$i"]  = 0;
    $livememarray["G2A$i"]  = 0;
    $livememarray["G2P$i"]  = 0;
    $livememarray["G3V$i"]  = 0;
    $livememarray["G3A$i"]  = 0;
    $livememarray["G3P$i"]  = 0;
    $livememarray["FRQ$i"]  = 0;
    $livememarray["EFF$i"]  = 0;
    $livememarray["INVT$i"] = 0;
    $livememarray["BOOT$i"] = 0;
    $livememarray["SSR$i"]  = 0;
    $livememarray["KWHT$i"] = 0;
    if (!isset($memarray["pmotd$i"])) {
        $memarray["pmotd$i"]  = 0;
        $memarray["pmotdt$i"] = $nowUTCs;
    }
    if (!isset($memarray['pmotdmulti'])) {
        $memarray['pmotdmulti']  = 0;
        $memarray['pmotdtmulti'] = $nowUTCs;
    }
    
    if (!isset($memarray["invtstat$i"])) {
        $memarray["invtstat$i"] = '---';
    }
    if (!isset($memarray["5minflag$i"])) {
        $memarray["5minflag$i"] = false;
    }
    if (!isset($memarray["mailq$i"])) {
        $memarray["mailq$i"] = 0;
    }
    if (!isset($memarray["AWt$i"])) {
        $memarray["AWt$i"]     = $nowUTCs; // Reset AW msg
        $memarray["AWriso$i"]  = 0;
        $memarray["AWileak$i"] = 0;
        $memarray["peakotd$i"] = 0; // Peak
        $memarray["peakoat$i"] = 0;
    }
}

// PVoutput config
$pvoconsu = false; // Consumption
for ($i = 1; $i <= $NUMPVO; $i++) {
    if (${'PVOC' . $i} != 'no') {
        $pvoconsu = true;
    }
}

if ($numsma > 0) {
    $ndaemon = $numsma - 1; // Call SMA Daemon
}

function pushover($uid, $title, $msg) // Push-over
{
    curl_setopt_array($ch = curl_init(), array(
        CURLOPT_URL => 'https://api.pushover.net/1/messages.json',
        CURLOPT_TIMEOUT => 10,
        CURLOPT_POSTFIELDS => array(
            'token' => 'soh71JI4Eln1eecvyV8G87NrRiLwxS',
            'user' => $uid,
            'message' => $msg
        )
    ));
    curl_exec($ch);
    curl_close($ch);
}

/////  Main memory
$data = json_encode($memarray);
$size = mb_strlen($data, 'UTF-8');
@$shmid = shmop_open($MEMORY, 'a', 0, 0);
if (!empty($shmid)) {
    shmop_delete($shmid);
    shmop_close($shmid);
}

@$shmid = shmop_open($MEMORY, 'c', 0644, $size);
if (!empty($shmid)) {
    shmop_write($shmid, $data, 0);
    shmop_close($shmid);
} else {
    die("Abording. Can't write in memory #$MEMORY.\n");
}
///// Live memory
$data = json_encode($livememarray);
$size = mb_strlen($data, 'UTF-8');
@$shmid = shmop_open($LIVEMEMORY, 'a', 0, 0);
if (!empty($shmid)) {
    shmop_delete($shmid);
    shmop_close($shmid);
}
@$shmid = shmop_open($LIVEMEMORY, 'c', 0644, $size);
if (!empty($shmid)) {
    shmop_write($shmid, $data, 0);
    shmop_close($shmid);
} else {
    die("Abording. Can't write in live memory #$LIVEMEMORY.\n");
}
?>
